package hero.client.manager;

/*
*
* JProjectList.java - 
* Copyright (C) 2003 Ecoo Team
* valdes@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import hero.interfaces.Constants;
import hero.util.EventConstants;
import hero.util.BonitaClient;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Collection;

import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.ImageIcon;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;

public class JProjectList
	extends JPanel
	implements PropertyChangeListener, Constants.Nd, EventConstants, MouseListener {

static java.util.ResourceBundle resource = java.util.ResourceBundle.getBundle("resources.Traduction")/*#BundleType=List*/;

	private JList projectList = null;
	private DefaultListModel model;
	private JScrollPane jsppl;
	private MListener ml;
	public final static String SELECTED = "selected";
	public final static String PROJECTCLOSE = "close";
	public Hashtable projects = new Hashtable();
	private hero.client.grapheditor.Frame frame;
	private BonitaClient soapclient;
	private Collection actualProjects;
	public final static String imageBase = "images/";
	public final static ImageIcon icon = new ImageIcon(Thread.currentThread().getContextClassLoader().getResource(imageBase + "icon.png"));

	public JProjectList(BonitaClient soapclient,MListener ml,Collection projects) {
		try {
			this.actualProjects = projects;
			ml.addEventProjectListener(this);
			model = new DefaultListModel();
			projectList = new JList(model);
			projectList.setCellRenderer(new ManagerCellRenderer());

			jsppl = new JScrollPane(projectList);
			this.setLayout(new BorderLayout());
			this.setBackground(new Color(177,177,251));
			this.add(new JLabel(resource.getString("jprojectlist.project")), BorderLayout.NORTH);
			this.add(jsppl, BorderLayout.CENTER);
			projectList.addMouseListener(this);

			this.soapclient = soapclient;
			Iterator i = projects.iterator();

			while (i.hasNext()) {
				String p = (String) i.next();
				ListItem li = new ListItem(Color.white, p);
				model.addElement(li);
			}

		} catch (Exception e) {
		}
	}
	
	public void newProject() {
			String projectName = (String) JOptionPane.showInputDialog(null,resource.getString("jprojectlist.name"), resource.getString("jprojectlist.new"), JOptionPane.QUESTION_MESSAGE,icon,null,null);
			while (projectName != null && projectName.equals("")) {
				JOptionPane.showMessageDialog(null,resource.getString("jprojectlist.enter"),resource.getString("jprojectlist.new"),JOptionPane.QUESTION_MESSAGE,icon);
				projectName = (String) JOptionPane.showInputDialog(null, resource.getString("jprojectlist.name"), resource.getString("jprojectlist.new"),JOptionPane.QUESTION_MESSAGE,icon,null,null);
			}
			if (projectName != null) {
				try {
					if (exists(projectName)) {
						JOptionPane.showMessageDialog(null,resource.getString("jprojectlist.exist"),resource.getString("jprojectlist.name"), JOptionPane.INFORMATION_MESSAGE,icon);
					} else {				
						soapclient.createProject(projectName);
					}
				} catch (Exception ex) {
					JOptionPane.showMessageDialog(null,resource.getString("jprojectlist.exist"),resource.getString("jprojectlist.new"),JOptionPane.INFORMATION_MESSAGE,icon);
				}
			}
		}
		
		private boolean exists(String project) {
			try {
				Object[] elems = this.actualProjects.toArray();
				for (int i = 0; i < elems.length; i++) {
					if (((String) elems[i]).equalsIgnoreCase(project))
						return true;
				}
				return false;
			} catch (Exception e) {
				e.printStackTrace();
			}
			return true;
		}


	public void mouseReleased(MouseEvent e) {
		try {
			if (!projectList.isSelectionEmpty()) {
				if ((e.getModifiers() & java.awt.event.InputEvent.BUTTON3_MASK)
					!= 0) {
					JPopupMenu menu = new JPopupMenu();
					PopupMenu(menu);

					Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
					Dimension size = menu.getPreferredSize();

					// Flip along screen

					int x = e.getX();
					int y = e.getY();

					menu.show(this,e.getX()	- (int) jsppl.getViewport().getViewPosition().getX(),e.getY()- (int) jsppl.getViewport().getViewPosition().getY());

				} else if (e.getClickCount() == 1) {
					String pl =((ListItem) projectList.getSelectedValue()).getValue();
					firePropertyChange(SELECTED, "", pl);
				} else if (e.getClickCount() == 2) {
					try {

						if (!projects.containsKey(((ListItem) projectList.getSelectedValue()).getValue())) {
							frame =	new hero.client.grapheditor.Frame(((ListItem) projectList.getSelectedValue()).getValue(),soapclient, false);
							frame.setSize(new Dimension(500, 400));
							frame.setVisible(true);
							projects.put(((ListItem) projectList.getSelectedValue()).getValue(),frame);
							frame.addPropertyChangeListener(PROJECTCLOSE, this);
						} else {
							frame =(hero.client.grapheditor.Frame) projects.get(((ListItem) projectList.getSelectedValue()).getValue());
							frame.requestFocus();
						}
					} catch (Exception ce) {
						JOptionPane.showMessageDialog(null,resource.getString("jprojectlist.modify")+ ((ListItem) projectList.getSelectedValue()).getValue()+ resource.getString("jprojectlist.proj"),resource.getString("jprojectlist.open"),JOptionPane.INFORMATION_MESSAGE,icon);
					}
				}
			}
		} catch (Exception e1){
			JOptionPane.showMessageDialog(null,resource.getString("jprojectlist.error"),resource.getString("jprojectlist.interror"),JOptionPane.INFORMATION_MESSAGE,icon);
		}
	}

	public void PopupMenu(JPopupMenu menu) {
		JMenuItem mi;
		ClassLoader cl = this.getClass().getClassLoader();

		mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("jprojectlist.clone")));
		mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cloneProject(((ListItem) projectList.getSelectedValue()).getValue());
			}
		});
		
		mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("jprojectlist.inst")));
		mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				instantiateProject(((ListItem) projectList.getSelectedValue()).getValue());
			}
		});

		mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("jprojectlist.details")));
		mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				BrowserControl.displayURL(java.lang.System.getProperty("bonita.host")
						+ "/bonita/protected/Action.jsp?projectname="
						+ ((ListItem) projectList.getSelectedValue()).getValue());
			}
		});

		mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("jprojectlist.delete")));
		mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				deleteProject(((ListItem) projectList.getSelectedValue()).getValue());
			}
		});
	}

	public void deleteProject(String project) {
		try {
			int option = JOptionPane.showConfirmDialog(null,resource.getString("jprojectlist.deleteproject"),resource.getString("jprojectlist.delete"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE,icon);
			if (option == JOptionPane.OK_OPTION) {
				if (soapclient.deleteProject(project) == true)
					JOptionPane.showMessageDialog(null,resource.getString("jprojectlist.proj") + project + " " +resource.getString("jprojectlist.remove"),resource.getString("jprojectlist.delete"),JOptionPane.INFORMATION_MESSAGE,icon);
			}
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null,e.getMessage(), resource.getString("jprojectlist.delete"),JOptionPane.INFORMATION_MESSAGE,icon);
		}
	}

	public void cloneProject(String project) {
		try {
			String newProject =	(String)JOptionPane.showInputDialog(null,resource.getString("jprojectlist.name"),resource.getString("jprojectlist.clone"),JOptionPane.QUESTION_MESSAGE,icon,null,null);

			while (newProject != null && newProject.equals("")) {
				JOptionPane.showMessageDialog(null,resource.getString("jprojectlist.enternew"),resource.getString("jprojectlist.clone"),JOptionPane.INFORMATION_MESSAGE,icon);
				newProject =(String) JOptionPane.showInputDialog(null,resource.getString("jprojectlist.name"),resource.getString("jprojectlist.clone"),JOptionPane.INFORMATION_MESSAGE,icon,null,null);
			}
			if (newProject != null)
				soapclient.cloneProject(project, newProject);

		} catch (Exception e) {
			JOptionPane.showMessageDialog(null,resource.getString("jprojectlist.exist"),resource.getString("jprojectlist.clone"),JOptionPane.INFORMATION_MESSAGE,icon);
		}
	}
	
	public void instantiateProject(String project) {
		try {
			soapclient.instantiateProject(project);
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null,resource.getString("jprojectlist.inst.error"),resource.getString("jprojectlist.inst"),JOptionPane.INFORMATION_MESSAGE,icon);
		}
	}

	public void changeEvent(Object[] e, String projectName) {
		model.clear();
		this.actualProjects.remove(projectName);
		e = actualProjects.toArray(); 
	    int i = 0;
		for (i = 0; i < e.length; i++) {
			ListItem li = new ListItem(Color.white, e[i].toString());
			model.addElement(li);
		}
	}
	public void addElement(String projectName) {
		if (!exists(projectName)){
		ListItem li = new ListItem(Color.white, projectName);
		model.addElement(li);
		actualProjects.add(projectName);
		}
	}

	public void propertyChange(PropertyChangeEvent e) {
		try {
			if (e.getPropertyName().equals(PROJECTCLOSE)) {
				projects.remove(e.getNewValue());
			}
		} catch (Exception e1) {
			e1.printStackTrace();
		}
	}

	// Rest of mouse listener is empty
	public void mousePressed(MouseEvent e) {
	}
	public void mouseEntered(MouseEvent e) {
	}
	public void mouseExited(MouseEvent e) {
	}
	public void mouseClicked(MouseEvent e) {
	}

}
