/*
*
* PerformerAssign.java - 
* Copyright (C) 2003 Ecoo Team
* charoy@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package hero.performerAssign;

import hero.interfaces.BnNodeLocal;
import hero.util.HeroException;
import java.io.Serializable;

public abstract class PerformerAssign implements Serializable{


    public static final int CALLBACK=0;
	public static final int PROPERTY=1;
	
    private String name;
    private int type;

    public static PerformerAssign make(String name, int type) throws HeroException {
	if (type==CALLBACK) return new CallbackPerformerAssign(name,type);
	if (type==PROPERTY) return new PropertyPerformerAssign(name,type);
	throw new HeroException("Wrong PerformerAssign Type " + type);
    }

    protected PerformerAssign(String name, int type) {
	this.name=name;
	this.type=type;
    }

    public String getName() {return this.name;}
    public void setName(String name) {this.name=name;}

    public int getType() {return this.type;}
    public void setType(int type) {this.type=type;}

    public String toXML() {
	String result=new String();
	result="<performerAssign name=\""+this.getName()+
	    "\" type=\""+this.getType()+"\"/>";
	return result;
    }

    public abstract void execute(Object bean, int type, BnNodeLocal role, String userName) throws HeroException;

}
