package hero.performerAssign;

/*
* 02/01/2002 - 15:24:07
*
* CallbackPerformerAssign.java - 
* Copyright (C) 2002 Ecoo Team
* charoy@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import hero.interfaces.BnNodeLocal;
import hero.util.HeroException;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import org.apache.log4j.Category;

public class PropertyPerformerAssign extends PerformerAssign {

    // Utility variable
    private static final Category log = Category.getInstance(PropertyPerformerAssign.class);


    public PropertyPerformerAssign(String name, int type) {
	super(name,type);
    }

    public void execute(Object bean, int type, BnNodeLocal node, String userName) throws HeroException {
	log.debug("execute: type="+type+" node="+node.getName());
		
	try {    
		Class clperformerAssign=Class.forName("hero.performerAssign.PropertySelectActors");
	    NodePerformerAssignI ndh =(NodePerformerAssignI)clperformerAssign.newInstance();
	    Class[] param={
		Class.forName("java.lang.Object"),
		Class.forName("hero.interfaces.BnNodeLocal"),
		Class.forName("java.lang.String")};
	    Method evth=clperformerAssign.getMethod("selectActors",param);
	    Object[] o={bean,node,userName};
	    evth.invoke(ndh,o);
	} catch (InvocationTargetException ite) {
		ite.printStackTrace();
	    throw new HeroException("Failure during performerAssign execution : " + ite.getMessage());
	} catch (Exception e) {
	    throw new HeroException("Dynamic invocation of performerAssign failed :"+this.getName()+" Node:"+node.getName()+"--> performerAssign type = "+type+" ///"+e);
	}
    }


}
