package hero.mapper;

import hero.util.HeroException;
import hero.interfaces.BnRoleLocal;

// use of the ProjectSession Bean
import hero.interfaces.ProjectSessionLocalHome;
import hero.interfaces.ProjectSessionLocal;
import hero.interfaces.ProjectSessionUtil;

import javax.ejb.SessionContext;

import java.util.*;


public class PropertiesGroupMembers implements hero.mapper.RoleMapperI {

    public void searchMembers(Object b,BnRoleLocal n, String userName) throws HeroException {	
	    
	    String roleName=n.getName();
	    String projectName=n.getBnProject().getName();	    
	    
		try {
			ProjectSessionLocalHome projecth = (ProjectSessionLocalHome)ProjectSessionUtil.getLocalHome();
			ProjectSessionLocal projectsession = projecth.create();
			projectsession.initProject(projectName);				
			
			// logs trace
			System.out.println("[PropertiesGroupMembers] instanceCreator : " + userName + " BnRole name: " + roleName + " - Project name = " + projectName);

			// add user to the project instance: not useful because the authenticated user is already defined within the project
			// projectsession.addUser(userName);
				
			// set the user role
			projectsession.setUserRole(userName, roleName);
			
			// logs trace
			System.out.println("Set role: " + roleName + " to user: " + userName );
			
			projectsession.remove();		
		
		} catch (Exception e) {		    
			throw new HeroException("Error setting role : " + roleName + " with properties mapper " + e.getMessage());
		}				    
    } 

}















